#
# Name: 
# Description: 
#

import color
import StdDraw
import math

class Balloon:
    
    # Construct a Balloon with the following settings:
    #   x         - x center of the main part of the balloon
    #   y         - y center of the main part of the balloon
    #   maxRadius - maximum radius of the balloon, any bigger and it will pop!
    #   label     - text label that is display in the center of the balloon
    #   red       - red component of the balloon's color, an interger in [0, 255]
    #   green     - green component of the balloon's color, an interger in [0, 255]
    #   blue      - blue component of the balloon's color, an interger in [0, 255]
    #   radius    - starts at 0.0
    #   popped    - starts at False
    #   WARNING_LEVEL   - constant 0.8, or 80% of percent of radius for balloon overinflation
    #   TIE_SIZE_FACTOR - constant 0.2, or 20% of percent of radius for balloon tie
    def __init__(self, x, y, maxRadius, label, red, green, blue):
        #
        #   YOUR CODE HERE
        #
    
    # Draw the balloon using StdDraw. 
    # (see instructions for further details)
    def draw(self):
        #
        #   YOUR CODE HERE
        #
       
    # Check if this balloon has a label exactly equal to the specified text
    def matches(self, label):
        #
        #   YOUR CODE HERE
        #

    # Determine the balloon's lift based on its spherical volume
    # and how much lift each unit of volume generates (liftPerUnitVolume).
    # A popped balloon generates 0.0 lift. 
    # (see instructions for further details and volume formula)
    def lift(self, liftPerUnitVolume):
        #
        #   YOUR CODE HERE
        #

    # Try and increase the radius of the balloon by the specified amount.
    # If the balloon is popped, this has no effect.
    def inflate(self, increaseRadiusBy):
        #
        #   YOUR CODE HERE
        #
        

#
# The code below is only so you can test your Balloon class as you write it. If
#  you've implemented the class correctly, your output should match the output
#  shown on the exam.
#
# To run this code, type "python Balloon.py" at the command prompt
#
# This will not be graded, you can change it however you like if you want
#  to try additional tests. DON'T remove the first line, though.
#

if __name__ == "__main__":
    LIFT_HELIUM   = 10.9; # Newtons of lift per m^3 of helium 
    LIFT_HYDROGEN = 11.8; # Newtons of lift per m^3 of hydrogen

    #StdDraw.setFont(new Font("SansSerif", Font.BOLD, 18));

    # Balloon that hasn't been pumped up yet
    b1 = Balloon(0.2, 0.9, 0.2, "a", 255, 128, 0)
    b1.draw()
    print("b1, lift = %.4f, radius = %.4f, popped = %s, matches(a) = %s, matches(b) = %s"
                %(b1.lift(LIFT_HELIUM), 
                b1.radius, 
                str(b1.popped),
                str(b1.matches("a")),
                str(b1.matches("b"))))
        
    # Balloon with a single pump
    b2 = Balloon(0.2, 0.8, 0.2, "b", 255, 128, 0)
    b2.inflate(0.02)
    b2.draw()
    print("b2, lift = %.4f, radius = %.4f, popped = %s, matches(a) = %s, matches(b) = %s" 
                %(b2.lift(LIFT_HELIUM), 
                b2.radius, 
                str(b2.popped),
                str(b2.matches("a")),
                str(b2.matches("b"))))
        
    # Balloon with a two pumps
    b3 = Balloon(0.2, 0.7, 0.2, "c", 204, 0, 204)
    b3.inflate(0.02)
    b3.inflate(0.02)
    b3.draw()
    print("b3, lift = %.4f, radius = %.4f, popped = %s, matches(a) = %s, matches(b) = %s"
                %(b3.lift(LIFT_HELIUM), 
                b3.radius, 
                str(b3.popped),
                str(b3.matches("a")),
                str(b3.matches("b"))))
        
    # Balloon with enough pumping to bring it above warning level
    b4 = Balloon(0.2, 0.5, 0.1, "d", 204, 0, 204)
    b4.inflate(0.081)
    b4.draw()
    print("b4, lift = %.4f, radius = %.4f, popped = %s, matches(a) = %s, matches(b) = %s"
                %(b4.lift(LIFT_HYDROGEN), 
                b4.radius, 
                str(b4.popped),
                str(b4.matches("a")),
                str(b4.matches("b"))))

    # Balloon that has been pumped past its maximum level
    b5 = Balloon(0.2, 0.2, 0.2, "e", 204, 0, 204);
    b5.inflate(0.18);
    b5.inflate(0.06);
    b5.inflate(0.06);
    b5.draw();
    print("b5, lift = %.4f, radius = %.4f, popped = %s, matches(a) = %s, matches(b) = %s"
                %(b5.lift(LIFT_HYDROGEN), 
                b5.radius, 
                str(b5.popped),
                str(b5.matches("a")),
                str(b5.matches("b"))))

    StdDraw.show(2000)

